﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
Das Gui kann schwer laggen, wenn Löschweitergabe eine Kaskade untergeordneter Löschungen auslöst. Daher SuspendLogic untergeordneter BindingSources
#End If ' -------------- Imports & Options --------------------
#End Region 'FileHeader

Namespace Global.System.Data

	Partial Public Class DataTableAttach

		Private _ChildAttachs As DataTableAttach()
		Private _FloodFillFlag As Boolean

		Private Sub _RowDeletingOrDeleted(sender As Object, e As DataRowChangeEventArgs) Handles _ActiveTable.RowDeleting, _ActiveTable.RowDeleted
			'since subscribed both events it toggles 2 times, and everything is as before ;)
			ToggleChildBindingSources()
		End Sub

		''' <summary> recursively (floodfill) toggle Data-Synchronisation of all Child-BindingSources </summary>
		Private Sub ToggleChildBindingSources()
			_FloodFillFlag = Not _FloodFillFlag '                  floodfill: toggling the Flag marks Items as already visited 
			If _ChildAttachs.Null Then Dim x = New DatasetAttach(Table.DataSet) 'ggfs initialisieren
			For Each chld In _ChildAttachs
				With chld
					If ._FloodFillFlag <> _FloodFillFlag Then
						.SuspendLogic(_FloodFillFlag, Suspend.BindingSources)
						.ToggleChildBindingSources()
					End If
				End With
			Next
		End Sub

	End Class
End Namespace
