﻿Imports MySql.Data.MySqlClient
Imports System.Data.Common

Public Class MySqlServerPersistance : Inherits DbPersistanceBase

	Public Sub New(connectionString As String, dts As DataSet)
		MyBase.New(New MySqlConnection(connectionString), dts)
	End Sub

	Protected Overrides Sub InitAutoIncrement(table As DataTable, adp As DbDataAdapter)
		'Bei AutoIncrement-Primkeys wird dem Insert-CommandText ein Select-Command angehängt, welches den Db-seitig generierten Pk rücktransportiert
		Dim pkCol = table.PrimaryKey(0).ColumnName
		'adp.InsertCommand.CommandText &= String.Format("; SELECT [{0}] FROM [{1}] WHERE [{0}] = LAST_INSERT_ID()", pkCol, table.TableName)
		adp.InsertCommand.CommandText &= String.Format("; SELECT `{0}` FROM `{1}` WHERE `{0}` = LAST_INSERT_ID()", pkCol, table.TableName)
		adp.InsertCommand.UpdatedRowSource = UpdateRowSource.Both 'UpdateRowSource.Both
	End Sub

End Class
