﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics
Imports System.Data

Namespace Global.System
	Public Module EnumX

		''' <summary>a typed wrapper around Enum.GetValues</summary>
		<DebuggerStepThrough(), Extension()>
		Public Function EnumGetValues(Of T As Structure)(enm As T) As T()
			Return DirectCast([Enum].GetValues(enm.GetType), T())
		End Function

		<DebuggerStepThrough(), Extension()>
		Public Function AndChangeAdd(dataRowAction As DataRowAction) As DataRowAction
			Return dataRowAction And (Data.DataRowAction.Add Or Data.DataRowAction.Change)
		End Function

		<DebuggerStepThrough(), Extension()>
		Public Function AndDeletedDetached(dataRowState As DataRowState) As DataRowState
			Return dataRowState And (DataRowState.Deleted Or DataRowState.Detached)
		End Function

	End Module

End Namespace

