﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics, System.Collections

Namespace Global.System
	'Public Class [Enum]
	'   Public Shared Sub SetFlag(
	'End Class


	Public Module MiscX

		'<Extension(), DebuggerStepThrough()>
		'Public Function CallerName(Of T)(Subj As T, <CallerMemberName> Optional caller As String = "") As String
		'	Return caller
		'End Function
		''' <summary>returnt 0 für false, und 1 für True </summary>
		<Extension(), DebuggerStepThrough()>
		Public Function AsIndex(bool As Boolean) As Int32
			Return Convert.ToInt32(bool)
		End Function
		<Extension(), DebuggerStepThrough()>
		Public Sub [Xor](ByRef Subj As Boolean, Value As Boolean)
			Subj = Subj Xor Value
		End Sub
		<Extension(), DebuggerStepThrough()>
		Public Sub [Or](ByRef Subj As Boolean, Value As Boolean)
			Subj = Subj Or Value
		End Sub
		<Extension(), DebuggerStepThrough()>
		Public Function Abs(Subj As Integer) As Integer
			Return If(Subj < 0, -Subj, Subj)
		End Function
		<Extension(), DebuggerStepThrough()>
		Public Function TryParseX(ByRef Subj As Integer, s As String) As Boolean
			Return Integer.TryParse(s, Subj)
		End Function
		<Extension(), DebuggerStepThrough()>
		Public Function TryParseX(ByRef Subj As Decimal, s As String) As Boolean
			Return Decimal.TryParse(s, Subj)
		End Function
		<Extension(), DebuggerStepThrough()>
		Public Function TryParseX(ByRef Subj As Double, s As String) As Boolean
			Return Double.TryParse(s, Subj)
		End Function
		<Extension(), DebuggerStepThrough()>
		Public Function TryParseX(ByRef Subj As Single, s As String) As Boolean
			Return Single.TryParse(s, Subj)
		End Function
		<Extension(), DebuggerStepThrough()>
		Public Function TryParseX(ByRef Subj As Date, s As String) As Boolean
			Return Date.TryParse(s, Subj)
		End Function

#Region "Integer.Times()-Extension"
		<Extension(), DebuggerStepThrough()>
		Public Sub Times(n As Integer, action As Action)
			For i = 0 To n - 1 : action() : Next
		End Sub
		<Extension(), DebuggerStepThrough()>
		Public Sub Times(n As Integer, action As Action(Of Integer))
			For i = 0 To n - 1 : action(i) : Next
		End Sub
		<Extension(), DebuggerStepThrough()>
		Public Function TimesRepeat(Of T)(n As Integer, item As T) As IEnumerable(Of T)
			Return Enumerable.Repeat(item, n)
		End Function
		<Extension(), DebuggerStepThrough()>
		Public Function Times(Of T)(n As Integer, generate As Func(Of T)) As IEnumerable(Of T)
			Return From i In Enumerable.Range(0, n) Select generate.Invoke
		End Function
		<Extension(), DebuggerStepThrough()>
		Public Function Times(Of T)(n As Integer, convert As Func(Of Integer, T)) As IEnumerable(Of T)
			Return From i In Enumerable.Range(0, n) Select convert.Invoke(i)
		End Function
		'<Extension(), DebuggerStepThrough()> _
		'Public Function Times(Of T)(n As Integer, item As T) As IEnumerable(Of T)
		'   Return Enumerable.Repeat(item, n)
		'End Function
		''' <summary> aufsteigende Zahlenreihe mit n Elementen, beginnend bei 0 </summary>
		<Extension(), DebuggerStepThrough()>
		Public Function Times(n As Integer) As Sequence
			Return New Sequence With {._Count = n}
		End Function

		Public Class Sequence : Implements IEnumerable(Of Integer)
			Private _Start As Integer = 0
			Private _Step As Integer = 1
			Public _Count As Integer
			''' <summary> Setzt die Schrittweite der Zahlenreihe </summary>
			<DebuggerStepThrough()>
			Public Function [Step](value As Integer) As Sequence
				_Step = value
				Return Me
			End Function
			''' <summary> Setzt den Startwert der Zahlenreihe </summary>
			<DebuggerStepThrough()>
			Public Function From(start As Integer) As Sequence
				_Start = start
				Return Me
			End Function
			<DebuggerStepThrough()>
			Public Function From(Of T)(start As Integer, convert As Func(Of Integer, T)) As IEnumerable(Of T)
				Return From i In From(start) Select convert(i)
			End Function
			<DebuggerStepThrough()>
			Public Sub From(start As Integer, action As Action(Of Integer))
				For i = start To (_Count - 1) * _Step + start Step _Step : action(i) : Next
			End Sub
			<DebuggerStepThrough()>
			Public Function GetEnumerator() As IEnumerator(Of Integer) Implements IEnumerable(Of Integer).GetEnumerator
				Return (From i In Enumerable.Range(0, _Count) Select i * _Step + _Start).GetEnumerator
			End Function
			Private Function GetEnumerator1() As IEnumerator Implements IEnumerable.GetEnumerator
				Return GetEnumerator()
			End Function
		End Class
#End Region 'Integer.Times()-Extension

		'<Extension()> _
		'Public Function Replace(mt As System.Text.RegularExpressions.Match, text As String, replacement As String) As String
		'   Return Date.TryParse(s, Subj)
		'End Function

	End Module

End Namespace
