﻿Imports System.Runtime.CompilerServices

Namespace Global.System
	Public Class Nops(Of T)
		Public Shared ReadOnly Accept As New Func(Of T, Boolean)(Function(o) True)
		Public Shared ReadOnly Reject As New Func(Of T, Boolean)(Function(o) False)
		Public Shared ReadOnly Echo As New Func(Of T, T)(Function(o) o)
		Public Shared ReadOnly Nop As New Action(Of T)(AddressOf modNops.Nop)
	End Class
	Public Class Nops(Of T, T2)
		Public Shared ReadOnly Instance As New Action(Of T, T2)(AddressOf modNops.Nop)
	End Class

	Public Class Nops
		Public Shared ReadOnly Nop As New Action(AddressOf modNops.Nop)
		Public Shared Function Echo(Of T)() As Func(Of T, T)
			Return System.Nops(Of T).Echo
		End Function
		Public Shared Function Bin(Of T)() As Action(Of T)
			Return System.Nops(Of T).Nop
		End Function
		Public Shared Function Bin(Of T, T2)() As Action(Of T, T2)
			Return System.Nops(Of T, T2).Instance
		End Function
		Public Shared ReadOnly Invert As New Func(Of Boolean, Boolean)(Function(b) Not b)
	End Class

	Public Module modNops

		Public Sub Nop()
		End Sub
		<Extension>
		Public Sub Nop(Of T)(arg As T)
		End Sub
		Public Sub Nop(Of T1, T2)(arg As T1, arg2 As T2)
		End Sub

	End Module
End Namespace
