﻿Imports System.ComponentModel

Namespace Global.System.Windows.Forms
	<DesignerCategory("Code")>
	Public Class NullableDateTimePicker : Inherits DateTimePicker

		<Bindable(True)>
		Public Shadows Property Value As Date?
			Get
				If Not Checked Then Return Nothing
				Return MyBase.Value
			End Get
			Set(value As Date?)
				If value.Equals(Me.Value) Then Return
				Checked = value.HasValue
				If value.HasValue Then MyBase.Value = value.Value
			End Set
		End Property

	End Class

End Namespace