﻿Namespace Global.System.Data

	Public Class DatasetViewer
		Public Shared Shadows Sub Show(tbl As DataTable, Optional ownerWindow As IWin32Window = Nothing)
			ShowViewer(tbl, ownerWindow, False)
		End Sub
		Public Shared Shadows Sub ShowDialog(tbl As DataTable, Optional ownerWindow As IWin32Window = Nothing)
			ShowViewer(tbl, ownerWindow, True)
		End Sub
		Public Shared Shadows Sub Show(dts As DataSet, Optional ownerWindow As IWin32Window = Nothing)
			ShowViewer(dts, ownerWindow, False)
		End Sub
		Public Shared Shadows Sub ShowDialog(dts As DataSet, Optional ownerWindow As IWin32Window = Nothing)
			ShowViewer(dts, ownerWindow, True)
		End Sub
		Private Shared Sub ShowViewer(dataSource As Object, ownerWindow As IWin32Window, showDialog As Boolean)
			Dim frm = New DatasetViewer
			frm.Grid.DataSource = dataSource
			With DirectCast(frm, Form)
				If showDialog Then
					Try
						.ShowDialog(ownerWindow) 'call the shadowed  base-function
					Finally
						.Dispose()
					End Try
				Else
					.Show(ownerWindow) 'call the shadowed base-function
				End If
			End With
		End Sub

		'Private Shared Sub frm_Closing(sender As Object, e As EventArgs) Handles Me.Closing
		'	getSetFormSizeAndLocation(True)
		'End Sub

		'Public Shared Sub getSetFormSizeAndLocation(StoreNewSizeAndPosition As Boolean)
		'	If My.Settings.DtsViewer_FormSizeAndLocation = "" Then My.Settings.DtsViewer_FormSizeAndLocation = $"{Me.Width},{Height}#{Location.X},{Location.Y}"
		'	If StoreNewSizeAndPosition Then My.Settings.DtsViewer_FormSizeAndLocation = $"{Width},{Height}#{Location.X},{Location.Y}"
		'	Dim sizeStr = My.Settings.DtsViewer_FormSizeAndLocation.LeftCut("#"c)
		'	Dim locationStr = My.Settings.DtsViewer_FormSizeAndLocation.RightCut("#"c)
		'	Me.Size = New Size With {.Width = CInt(sizeStr.LeftCut(","c)), .Height = CInt(sizeStr.RightCut(","c))}
		'	Me.Location = New Point With {.X = CInt(locationStr.LeftCut(","c)), .Y = CInt(locationStr.RightCut(","c))}
		'End Sub

	End Class

End Namespace