﻿Friend Module logic

    Private _AnzahlTestDaten As Integer = 1000

    Friend Sub ErzeugeTestDaten(Optional dgv As DataGridView = Nothing)
        Cursor.Current = Cursors.WaitCursor
        Dim datasource As Object = Nothing
        If dgv IsNot Nothing Then
            datasource = dgv.DataSource
            dgv.DataSource = Nothing
        End If
        Dim sw As New Stopwatch
        sw.Start()
        For i = 0 To _AnzahlTestDaten
            Dts.Anrede.AddAnredeRow(i.ToString, True)
        Next
        Dim stop1 = sw.Elapsed.TotalSeconds
        Dts.SaveDts()
        sw.Stop()
        Dim stop2 = sw.Elapsed.TotalSeconds
        Cursor.Current = Cursors.Default
        msgInformation($"Erzeugen: {stop1}{Environment.NewLine}Speichern: {stop2}")
        If dgv IsNot Nothing Then
            dgv.DataSource = datasource
        End If
    End Sub

    Friend Sub DatenLoeschen(Optional dgv As DataGridView = Nothing)
        Cursor.Current = Cursors.WaitCursor
        Dim datasource As Object = Nothing
        If dgv IsNot Nothing Then
            datasource = dgv.DataSource
            dgv.DataSource = Nothing
        End If
        Dim sw As New Stopwatch
        sw.Start()
        Dts.Anrede.ForEach(Sub(rw) rw.Delete())
        Dim stop1 = sw.Elapsed.TotalSeconds
        Dts.SaveDts()
        Dim stop2 = sw.Elapsed.TotalSeconds
        sw.Stop()
        Cursor.Current = Cursors.Default
        msgInformation($"Erzeugen: {stop1}{Environment.NewLine}Speichern: {stop2}")
        If dgv IsNot Nothing Then
            dgv.DataSource = datasource
        End If
    End Sub

End Module
